package javax.swing.plaf.nimbus;

import java.lang.ref.SoftReference;
import sun.awt.AppContext;
import java.awt.image.BufferedImage;

abstract class Effect
{
    Effect() {
    }
    
    abstract Effect.EffectType getEffectType();
    
    abstract float getOpacity();
    
    abstract BufferedImage applyEffect(BufferedImage p0, BufferedImage p1, int p2, int p3);
    
    protected static Effect.ArrayCache getArrayCache() {
        Effect.ArrayCache value = (Effect.ArrayCache)AppContext.getAppContext().get(Effect.ArrayCache.class);
        if (value == null) {
            value = new Effect.ArrayCache();
            AppContext.getAppContext().put(Effect.ArrayCache.class, value);
            return value;
        }
        return value;
    }
    
    enum EffectType
    {
        UNDER, 
        BLENDED, 
        OVER;
    }
    
    protected static class ArrayCache
    {
        private SoftReference<int[]> tmpIntArray;
        private SoftReference<byte[]> tmpByteArray1;
        private SoftReference<byte[]> tmpByteArray2;
        private SoftReference<byte[]> tmpByteArray3;
        
        protected ArrayCache() {
            this.tmpIntArray = null;
            this.tmpByteArray1 = null;
            this.tmpByteArray2 = null;
            this.tmpByteArray3 = null;
        }
        
        protected int[] getTmpIntArray(int n) {
            int[] referent;
            if (this.tmpIntArray == null || (referent = (int[])this.tmpIntArray.get()) == null || referent.length < n) {
                referent = new int[n];
                this.tmpIntArray = new SoftReference(referent);
                return referent;
            }
            return referent;
        }
        
        protected byte[] getTmpByteArray1(int n) {
            byte[] referent;
            if (this.tmpByteArray1 == null || (referent = (byte[])this.tmpByteArray1.get()) == null || referent.length < n) {
                referent = new byte[n];
                this.tmpByteArray1 = new SoftReference(referent);
                return referent;
            }
            return referent;
        }
        
        protected byte[] getTmpByteArray2(int n) {
            byte[] referent;
            if (this.tmpByteArray2 == null || (referent = (byte[])this.tmpByteArray2.get()) == null || referent.length < n) {
                referent = new byte[n];
                this.tmpByteArray2 = new SoftReference(referent);
                return referent;
            }
            return referent;
        }
        
        protected byte[] getTmpByteArray3(int n) {
            byte[] referent;
            if (this.tmpByteArray3 == null || (referent = (byte[])this.tmpByteArray3.get()) == null || referent.length < n) {
                referent = new byte[n];
                this.tmpByteArray3 = new SoftReference(referent);
                return referent;
            }
            return referent;
        }
    }
}
